﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.Linq;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Martian_WinForms
{
    static class Program
    {
        /// <summary>
        /// Главная точка входа для приложения.
        /// </summary>
        [STAThread]
        static void Main(string[] args)
        {
            string mapFile = "Map1.txt";
            for (int i = 0; i < args.Length; i++)
            {
                switch (args[i])
                {
                    case "-console":
                        Settings.ConsoleMode = true;
                        break;
                    case "-aimodeoff":
                        Settings.AIMode = false;
                        break;
                    case "-displaypathfinding":
                        Settings.DisplayPathFinding = true;
                        break;
                    default:
                        mapFile = args[i];
                        break;
                }
            }
            Application.EnableVisualStyles();
            Application.SetCompatibleTextRenderingDefault(false);
            Common.Tileset = new Bitmap("Images/Tileset.png");
            Common.PlayerImage = new Bitmap("Images/Player.png");
            Common.PopupsImages = new Bitmap("Images/Popups.png");
            Common.MonsterImage = new Bitmap("Images/Monster.png");
            Common.CubeImage = new Bitmap("Images/Tileset.png");
            try
            {
                Common.CurrentMap = new Map("Maps/" + mapFile);
                if (Common.CurrentMap.mapTiles == null) return;
            }
            catch (System.IO.FileNotFoundException)
            {
                Messaging.WriteEndGameMessage($"Карта \" {mapFile} +\" не найдена.");
                return;
            }
            Common.Player.FindPath();
            Common.GameStarted = true;
            if (!Settings.ConsoleMode && !Common.GameOver)
                Application.Run(new Form1());
            else if(Settings.ConsoleMode)
                ConsoleMode.Start();
        }
    }
}
