﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Martian_WinForms
{
    public static class Common
    {
        public static Player Player { get; set; }
        public static bool GameStarted { get; set; }
        public static bool GameOver { get; set; }
        public static Map CurrentMap { get; set; }
        public static Bitmap Tileset { get; set; }
        public static Bitmap PlayerImage { get; set; }
        public static Bitmap MonsterImage { get; set; }
        public static Bitmap CubeImage { get; set; }
        public static Bitmap PopupsImages { get; set; }
        public static List<Effect> Effects { get; set; }
        public static List<Popup> Popups { get; set; }

        public static void ActivateEffect(string effectName)
        {
            if (Settings.ConsoleMode) return;
            var effect = Effects.Where(e => e.name == effectName).First();
            effect.IsActivated = true;
        }

        public static void ShowPopup(Popup popup)
        {
            if (Settings.ConsoleMode) return;
            Popups.Add(popup);
        }
    }
}
