﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Martian_WinForms
{
    public class Cube : Movable
    {
        public Cube(int x, int y, Bitmap spriteImage) 
            : base(x, y, spriteImage) 
        {
            Speed = 8;
            XSpriteOffset = 288;
        }

        /// <summary>
        /// Показывает, с какой стороны следует толкать куб.
        /// </summary>
        public Direction ShouldBePushedFromSide { get; set; } = Direction.None;

        public override void Act() 
        {
            XSpriteOffset = 288;
        }

        public void Push(Direction direction)
        {
            Common.CurrentMap.mapTilesText[X, Y] = ".";
            Move(direction);
            foreach(var e in Common.CurrentMap.Cubes)
                e.ShouldBePushedFromSide = Direction.None;
            Common.Player.FindPath();
            Common.Player.CurrentPathPoints.Pop();
            Common.CurrentMap.mapTilesText[NextX, NextY] = "K";
        }

        public override void HandleReachedTileCenter()
        {
            base.HandleReachedTileCenter();
        }
    }
}
