﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Martian_WinForms
{
    public class Monster : Movable
    {
        public bool IsDead { get; set; }
        public Monster(int x, int y, Bitmap spriteImage) : base(x, y, spriteImage) 
        {
            Speed = 4;
        }

        public override void Act()
        {
            if (Common.GameOver) return;
            if (IsMoving)
            {
                MoveTowardsNext();
                return;
            }
            if (CurrentDirection == Direction.None) CurrentDirection = Direction.Right;
            PlanNextMove();
            MoveRandomly();
        }

        public void MoveRandomly()
        {
            while (Common.CurrentMap.IsWall(NextX, NextY))
            {
                switch (CurrentDirection)
                {
                    case Direction.Up:
                        if (Common.CurrentMap.IsWall(NextX, NextY))
                            CurrentDirection = Direction.Left;
                        break;
                    case Direction.Right:
                        if (Common.CurrentMap.IsWall(NextX, NextY))
                            CurrentDirection = Direction.Up;
                        break;
                    case Direction.Down:
                        if (Common.CurrentMap.IsWall(NextX, NextY))
                            CurrentDirection = Direction.Right;
                        break;
                    case Direction.Left:
                        if (Common.CurrentMap.IsWall(NextX, NextY))
                            CurrentDirection = Direction.Down;
                        break;
                }
                NextX = X;
                NextY = Y;
                PlanNextMove();
            }
        }

        public void PlanNextMove()
        {
            switch (CurrentDirection)
            {
                case Direction.Up: NextY--; break;
                case Direction.Right: NextX++; break;
                case Direction.Down: NextY++; break;
                case Direction.Left: NextX--; break;
            }
        }

        public override void MoveTowardsNext()
        {
            if (IsDead) XSpriteOffset = 384;
            else base.MoveTowardsNext();
        }
    }
}
