﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;

namespace Martian_WinForms
{
    public class SinglyLinkedList<T> : IEnumerable<T>
    {
        public readonly T Value;
        public readonly SinglyLinkedList<T> Previous;
        public readonly int Length;
        public readonly int playerHealthOnPoint;

        public SinglyLinkedList(T value, SinglyLinkedList<T> previous = null, int playerHealthOnPoint = 100)
        {
            Value = value;
            Previous = previous;
            Length = previous?.Length + 1 ?? 1;
            this.playerHealthOnPoint = playerHealthOnPoint;
        }

        public IEnumerator<T> GetEnumerator()
        {
            yield return Value;
            var pathItem = Previous;
            while (pathItem != null)
            {
                yield return pathItem.Value;
                pathItem = pathItem.Previous;
            }
        }

        IEnumerator IEnumerable.GetEnumerator()
        {
            return GetEnumerator();
        }
    }
}
