﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Timers;

namespace Martian_WinForms
{
    public static class ConsoleMode
    {
        public static void Start()
        {
            var timer = new Timer(200);
            timer.Elapsed += (s, e) => {
                timer.Enabled = false;
                MoveTimed();
                timer.Enabled = true;
            };
            timer.Enabled = true;
            Console.Clear();
            Console.WriteLine("Steps: 0 HP: 0");
            for (int Y = 0; Y < Common.CurrentMap.GetHeight; Y++)
            {
                for (int X = 0; X < Common.CurrentMap.GetWidth; X++)
                {
                    if (Common.Player.X == X && Common.Player.Y == Y)
                        Console.Write("!");
                    else
                        Console.Write(Common.CurrentMap.mapTilesText[X, Y]);
                }
                Console.WriteLine();
            }
            while (!Common.GameOver)
            {
                Common.Player.MoveTowardsNext();
            }
            timer.Stop();
            Console.ReadKey();
        }

        public static void MoveTimed()
        {
            if (Settings.AIMode && !Common.GameOver)
            {
                Common.Player.MoveAI();
            }
        }
        public static void RedrawTile(int X, int Y, bool DrawPlayer)
        {
            int origX = Console.CursorLeft;
            int origY = Console.CursorTop;
            Console.SetCursorPosition(X, Y + 1);
            if (DrawPlayer) Console.Write("!");
            else Console.Write(Common.CurrentMap.mapTilesText[X, Y]);
            Console.SetCursorPosition(0, 0);
            Console.Write(new string(' ', Console.WindowWidth));
            Console.SetCursorPosition(0, 0);
            Console.WriteLine("Steps: " + Common.Player.PathWalked.Length + " HP: " + Common.Player.Hp);
            Console.SetCursorPosition(origX, origY);

            if (!Settings.AIMode)
            {
                ConsoleKey key = Console.ReadKey().Key;
                switch (key)
                {
                    case ConsoleKey.UpArrow:
                        Common.Player.Move(Direction.Up);
                        break;
                    case ConsoleKey.RightArrow:
                        Common.Player.Move(Direction.Right);
                        break;
                    case ConsoleKey.DownArrow:
                        Common.Player.Move(Direction.Down);
                        break;
                    case ConsoleKey.LeftArrow:
                        Common.Player.Move(Direction.Left);
                        break;
                }
            }
        }
    }
}
