﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Martian_WinForms
{
    public class Effect
    {
        public readonly string name;
        public readonly Color color;
        public readonly double duration;
        public double TimeFactor { get; private set; }
        public bool IsActivated { get; set; }

        public Effect(string name, Color color, double duration)
        {
            this.name = name;
            this.color = color;
            this.duration = duration;
        }

        public void Continue()
        {
            if (IsActivated)
            {
                TimeFactor += 0.0166666666666667 * 4;
                if (TimeFactor > duration)
                {
                    TimeFactor = duration;
                    IsActivated = false;
                }
            }
            else if (TimeFactor > 0)
            {
                TimeFactor -= 0.0166666666666667 * 4;
                if (TimeFactor < 0) TimeFactor = 0;
            }
        }
    }
}
